DECLARE SUB allseen ()
DECLARE FUNCTION date2days! ()
DECLARE SUB footer (openfile%)
DECLARE SUB alleff ()
DECLARE SUB allkills ()
DECLARE SUB alldeaths ()
DECLARE SUB allskill ()
DECLARE SUB allrankings ()
DECLARE SUB skill ()
DECLARE SUB rankings ()
DECLARE SUB dumptable (openfile%)
DECLARE SUB showplayerdata ()
DECLARE SUB header (openfile%, text$)
DECLARE FUNCTION htmlString$ (name$)

CONST TRUE = -1
CONST FALSE = 0

COMMON SHARED outfile%
COMMON SHARED skills%
COMMON SHARED deaths%
COMMON SHARED kills%
COMMON SHARED ranks%
COMMON SHARED tempdata%
COMMON SHARED playerdata%
COMMON SHARED eff%
COMMON SHARED sline%
COMMON SHARED playerfile%
COMMON SHARED flags%
COMMON SHARED days!
COMMON SHARED rankage%


ON ERROR GOTO ErrorHandle

tempdata% = 64
playerfile% = 32
skills% = 31
deaths% = 30
kills% = 29
ranks% = 28
eff% = 27
playerdata% = 2
sline% = 1
flags% = 0
rankage% = 33

cline$ = UCASE$(COMMAND$)

IF INSTR(cline$, "-H") THEN
PRINT "STATMAKE [-h -p -d -s -k -r -e -a]"
PRINT "-h Show this help screen"
PRINT "-p skip player listing"
PRINT "-d skip death rankings"
PRINT "-s skip skill rankings"
PRINT "-k skip kill rankings"
PRINT "-r skip rank rankings"
PRINT "-e skip efficiency rankings"
PRINT "-a skip rank age rankings"
END
END IF

IF INSTR(cline$, "-P") THEN flags% = 1
IF INSTR(cline$, "-D") THEN flags% = flags% + 2
IF INSTR(cline$, "-S") THEN flags% = flags% + 4
IF INSTR(cline$, "-K") THEN flags% = flags% + 8
IF INSTR(cline$, "-R") THEN flags% = flags% + 16
IF INSTR(cline$, "-E") THEN flags% = flags% + 32
IF INSTR(cline$, "-A") THEN flags% = flags% + 64


IF flags% = 127 THEN
PRINT "Nothing to do :("
END
END IF

OPEN "players.dat" FOR INPUT AS #69
CLOSE #69

flags% = flags% XOR 255

IF (flags% AND 1) <> 0 THEN OPEN "players.html" FOR OUTPUT AS #playerfile%
IF (flags% AND 2) <> 0 THEN OPEN "deaths.html" FOR OUTPUT AS #deaths%
IF (flags% AND 4) <> 0 THEN OPEN "skill.html" FOR OUTPUT AS #skills%
IF (flags% AND 8) <> 0 THEN OPEN "kills.html" FOR OUTPUT AS #kills%
IF (flags% AND 16) <> 0 THEN OPEN "rank.html" FOR OUTPUT AS #ranks%
IF (flags% AND 32) <> 0 THEN OPEN "eff.html" FOR OUTPUT AS #eff%
IF (flags% AND 64) <> 0 THEN OPEN "rankage.html" FOR OUTPUT AS #rankage%



REM -----types------

TYPE PlayerStats
 handle AS STRING * 20
 kills AS LONG
 deaths AS LONG
 skill AS LONG
 lastseen AS LONG
END TYPE

DIM SHARED FileBuffer AS PlayerStats
DIM SHARED Player1 AS PlayerStats
DIM SHARED Player2 AS PlayerStats
DIM SHARED tempplayer AS PlayerStats

days! = date2days

REM ------end of types-------


OPEN "players.dat" FOR RANDOM AS #playerdata% LEN = LEN(FileBuffer)

CLS

LOCATE sline%, 1

PRINT "Player Datafile sorter - used with conread.exe"
PRINT "----------------------------------------------"
PRINT "By Richard Maxwell 3/3/1997"
PRINT "-"

sline% = sline% + 4

IF (flags% AND 1) = 0 THEN PRINT "Skipping player list": sline% = sline% + 1
IF (flags% AND 2) = 0 THEN PRINT "Skipping Death rankings": sline% = sline% + 1
IF (flags% AND 4) = 0 THEN PRINT "Skipping Skill rankings": sline% = sline% + 1
IF (flags% AND 8) = 0 THEN PRINT "Skipping Kill rankings": sline% = sline% + 1
IF (flags% AND 16) = 0 THEN PRINT "Skipping Rank rankings": sline% = sline% + 1
IF (flags% AND 32) = 0 THEN PRINT "Skipping Efficiency Rankings": sline% = sline% + 1
IF (flags% AND 64) = 0 THEN PRINT "Skipping Rank Age Rankings": sline% = sline% + 1


PRINT "-"
sline% = sline% + 1


IF (flags% AND 1) <> 0 THEN CALL header(playerfile%, "Player Number")
IF (flags% AND 2) <> 0 THEN CALL header(deaths%, "Deaths")
IF (flags% AND 4) <> 0 THEN CALL header(skills%, "Skill")
IF (flags% AND 8) <> 0 THEN CALL header(kills%, "Kills")
IF (flags% AND 16) <> 0 THEN CALL header(ranks%, "Rank")
IF (flags% AND 32) <> 0 THEN CALL header(eff%, "Efficiency")
IF (flags% AND 64) <> 0 THEN CALL header(rankage%, "Rank Age")


IF (flags% AND 1) <> 0 THEN
PRINT "Sorting By Player Number . . ."
CALL showplayerdata
sline% = sline% + 1
END IF

IF (flags% AND 16) <> 0 THEN
PRINT "Sorting By Rank . . ."
CALL allrankings
sline% = sline% + 1
END IF

IF (flags% AND 4) <> 0 THEN
PRINT "Sorting By skill . . ."
CALL allskill
sline% = sline% + 1
END IF

IF (flags% AND 8) <> 0 THEN
PRINT "Sorting By Kills . . ."
CALL allkills
sline% = sline% + 1
END IF

IF (flags% AND 2) <> 0 THEN
PRINT "Sorting By deaths . . ."
CALL alldeaths
sline% = sline% + 1
END IF

IF (flags% AND 32) <> 0 THEN
PRINT "Sorting By Efficiency . . ."
CALL alleff
sline% = sline% + 1
END IF

IF (flags% AND 64) <> 0 THEN
PRINT "Sorting By Rank Age . . ."
CALL allseen
sline% = sline% + 1
END IF


REM -----end of it all!-----

CLOSE
KILL "tempdata.tmp"
END

REM ----errors----

ErrorHandle:
IF ERR = 53 THEN
PRINT "Cannot find players.dat"
ELSE
PRINT "AAAAAA - What does this error number mean? - error:"; ERR
END IF
CLOSE
END

SUB alldeaths

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 0
count! = 1
pcount! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer
IF tempplayer.deaths > total% THEN total% = tempplayer.deaths
count! = count! + 1
LOOP

DO WHILE temp2% > -1

count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.deaths = total% AND tempplayer.skill >= 1000 THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,


LOCATE sline%, 1
PRINT "Players sorted by deaths :"; pcount!;
pcount! = pcount! + 1


IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)
END IF



IF tempplayer.deaths > temp2% AND tempplayer.deaths < total% THEN temp2% = tempplayer.deaths

count! = count! + 1
LOOP

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT " . . . Writing HTML"

CALL dumptable(deaths%)



END SUB

SUB alleff

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp2% = 0
temp$ = ""
total% = 0
count! = 1
pcount! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer

IF (tempplayer.deaths + tempplayer.kills) = 0 THEN
temp1% = 0
ELSE

IF tempplayer.deaths = 0 AND tempplayer.kills < 15 THEN
temp1% = 0
ELSE
temp1% = CINT(100 * tempplayer.kills / (tempplayer.deaths + tempplayer.kills))
END IF
END IF

IF temp1% > total% THEN total% = temp1%
count! = count! + 1
LOOP

DO WHILE temp2% > -1

count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF (tempplayer.deaths + tempplayer.kills) = 0 THEN
temp1% = 0
ELSE

IF (tempplayer.deaths = 0 AND tempplayer.kills < 15) THEN
temp1% = 0
ELSE
temp1% = CINT(100 * tempplayer.kills / (tempplayer.deaths + tempplayer.kills))
END IF
END IF

IF temp1% = total% AND tempplayer.skill >= 1000 THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,


LOCATE sline%, 1
PRINT "Players sorted by efficiency :"; pcount!;
pcount! = pcount! + 1


IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)
END IF



IF temp1% > temp2% AND temp1% < total% THEN temp2% = temp1%

count! = count! + 1
LOOP

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT " . . . Writing HTML"
CALL dumptable(eff%)


END SUB

SUB allkills

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 0
count! = 1
pcount! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer
IF tempplayer.kills > total% THEN total% = tempplayer.kills
count! = count! + 1
LOOP

DO WHILE temp2% > -1

count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.kills = total% AND tempplayer.skill >= 1000 THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,


LOCATE sline%, 1
PRINT "Players sorted by kills :"; pcount!;
pcount! = pcount! + 1



IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)
END IF



IF tempplayer.kills > temp2% AND tempplayer.kills < total% THEN temp2% = tempplayer.kills

count! = count! + 1
LOOP

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT " . . . Writing HTML"
CALL dumptable(kills%)



END SUB

SUB allrankings

REM -----RANK-----

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%

temp1% = 10000
temp2% = 0
temp$ = ""
total% = 0
count! = 1
pcount! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer


IF (tempplayer.kills - tempplayer.deaths) > total% THEN total% = tempplayer.kills - tempplayer.deaths
IF (tempplayer.kills - tempplayer.deaths) < temp1% THEN temp1% = tempplayer.kills - tempplayer.deaths
count! = count! + 1

LOOP

temp2% = temp1%

count! = 1

DO WHILE temp1% <> 1

GET #playerdata%, 1, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.skill >= 1000 AND (tempplayer.kills - tempplayer.deaths) = total% THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,

LOCATE sline%, 1
PRINT "Players sorted by rank :"; pcount!;
pcount! = pcount! + 1



IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)

END IF

IF (tempplayer.kills - tempplayer.deaths) > temp2% AND (tempplayer.kills - tempplayer.deaths) < total% THEN temp2% = (tempplayer.kills - tempplayer.deaths)

count! = count! + 1
LOOP

count! = 1
IF total% = temp2% THEN temp1% = 1 ELSE total% = temp2%: temp2% = temp1%

LOOP

CLOSE #tempdata%
PRINT " . . . Writing HTML"
CALL dumptable(ranks%)

END SUB

SUB allseen

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%

temp1% = days!
temp2% = 0
temp$ = ""
total% = 0
count! = 1
pcount! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer


IF (tempplayer.lastseen) > total% THEN total% = tempplayer.lastseen
IF (tempplayer.lastseen) < temp1% THEN temp1% = tempplayer.lastseen
count! = count! + 1

LOOP

temp2% = temp1%

count! = 1

DO WHILE temp1% <> 1

GET #playerdata%, 1, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.skill >= 1000 AND (tempplayer.lastseen) = total% THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,

LOCATE sline%, 1
PRINT "Players sorted by rank age:"; pcount!;
pcount! = pcount! + 1



IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)

END IF

IF (tempplayer.lastseen) > temp2% AND (tempplayer.lastseen) < total% THEN temp2% = (tempplayer.lastseen)

count! = count! + 1
LOOP

count! = 1
IF total% = temp2% THEN temp1% = 1 ELSE total% = temp2%: temp2% = temp1%

LOOP

CLOSE #tempdata%

PRINT " . . . Writing HTML"
CALL dumptable(rankage%)



END SUB

SUB allskill

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 1000
pcount! = 1
count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE (NOT EOF(playerdata%))
GET #playerdata%, count!, tempplayer
IF tempplayer.skill > total% THEN total% = tempplayer.skill
count! = count! + 1
LOOP

DO WHILE temp2% > -1

count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.skill = total% AND tempplayer.skill >= 1000 THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,

LOCATE sline%, 1
PRINT "Players sorted by skill :"; pcount!;
pcount! = pcount! + 1

IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)
END IF



IF tempplayer.skill > temp2% AND tempplayer.skill < total% THEN temp2% = tempplayer.skill

count! = count! + 1
LOOP

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 1000

LOOP
CLOSE #tempdata%
PRINT " . . . Writing HTML"
CALL dumptable(skills%)

END SUB

FUNCTION date2days!
year = VAL(RIGHT$(DATE$, 4))
month = VAL(LEFT$(DATE$, 2))
day = VAL(MID$(DATE$, 4, 2))
date2days! = day + (31 * (month - 1)) + (366 * (year - 1997))
END FUNCTION

DEFINT A-Z
SUB dumpStats

REM --------ranking tables--------


REM -----effency-----

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% + deaths% > 0 THEN

IF CINT(100 * totalgibs% / (totalgibs% + deaths%)) > total% THEN total% = CINT(100 * totalgibs% / (totalgibs% + deaths%))

END IF

LOOP

CLOSE #killdata%

DO WHILE temp2% > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% + deaths% = 0 THEN temp1% = 0 ELSE temp1% = CINT(100 * totalgibs% / (totalgibs% + deaths%))

IF temp1% = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, temp1%
IF temp1% > temp2% AND temp1% < total% THEN temp2% = temp1%

LOOP

CLOSE #killdata%

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Most Efficient<BR></FONT>"
PRINT #readstats%, "<FONT SIZE=-2>Kills<BR>"
PRINT #readstats%, "--------------<BR>"
PRINT #readstats%, "( Kills + Deaths )</FONT></FONT>"
PRINT #readstats%, "<P>-</P>"


PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Efficiency</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1%
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1%; "%</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "<P>-</P>"
PRINT #readstats%, "</TD>"
PRINT #readstats%, "</TR>"


REM -----kills-----

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%
IF totalgibs% > total% THEN total% = totalgibs%

LOOP

CLOSE #killdata%

DO WHILE temp2% > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, totalgibs%
IF totalgibs% > temp2% AND totalgibs% < total% THEN temp2% = totalgibs%

LOOP

CLOSE #killdata%

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Top Killers<BR></FONT></FONT>"
PRINT #readstats%, "<P>-</P>"


PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Kills</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1%
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1%; "</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "</TD>"

REM -----deaths-----

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1% = 100
temp2% = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%
IF deaths% > total% THEN total% = deaths%

LOOP

CLOSE #killdata%

DO WHILE temp2% > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF deaths% = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, deaths%
IF deaths% > temp2% AND deaths% < total% THEN temp2% = deaths%

LOOP

CLOSE #killdata%

IF total% = temp2% THEN temp2% = -1 ELSE total% = temp2%: temp2% = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Top Killees<BR></FONT></FONT>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Deaths</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1%
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1%; "</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "</TD>"
PRINT #readstats%, "</TR>"

PRINT #readstats%, "</TABLE>"


REM ^^^ end of check to see if any deaths occured.

REM ^^^ end of ranking tables

END SUB

DEFSNG A-Z
SUB dumptable (openfile%)


PRINT #openfile%, "</CENTER><PRE>"

PRINT #openfile%, "<FONT COLOR=#8080FF>Place         Handle                       Rank          Skill         Eff           Kills         Deaths        Rank Age</FONT>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%

count% = 0

DO WHILE NOT EOF(tempdata%)

count% = count% + 1

LINE INPUT #tempdata%, thandle$

PRINT #openfile%, count%, htmlString(thandle$)

LOOP

PRINT #openfile%, "</PRE>"

CALL footer(openfile%)

CLOSE #tempdata%

END SUB

SUB footer (openfile%)

PRINT #openfile%, "<CENTER><HR WIDTH=100%><DT>";
IF (flags% AND 16) <> 0 THEN PRINT #openfile%, "I <A HREF=rank.htm>Rank</A> "
IF (flags% AND 4) <> 0 THEN PRINT #openfile%, "I <A HREF=skill.htm>Skill</A> "
IF (flags% AND 32) <> 0 THEN PRINT #openfile%, "I <A HREF=eff.htm>Efficiency</A> "
IF (flags% AND 8) <> 0 THEN PRINT #openfile%, "I <A HREF=kills.htm>Kills</A> "
IF (flags% AND 2) <> 0 THEN PRINT #openfile%, "I <A HREF=deaths.htm>Deaths</A>"
IF (flags% AND 64) <> 0 THEN PRINT #openfile%, "I <A HREF=rankage.htm>Rank Age</A>"
IF (flags% AND 1) <> 0 THEN PRINT #openfile%, "I <A HREF=players.htm>Players</A>"
PRINT #openfile%, " I<HR WIDTH=100%></DT>"

PRINT #openfile%, "</CENTER></BODY></HTML>"

END SUB

SUB header (openfile%, text$)

PRINT #openfile%, "<!DOCTYPE HTML PUBLIC " + CHR$(34) + "-//W3C//DTD HTML 3.2//EN" + CHR$(34) + ">"
PRINT #openfile%, "<HTML>"
PRINT #openfile%, "<TITLE>Quake Console Statistics - By Richard Maxwell - Overall Stats</TITLE>"
PRINT #openfile%, "<META NAME=" + CHR$(34) + "Author" + CHR$(34) + " CONTENT=" + CHR$(34) + "Richard Maxwell" + CHR$(34) + ">"
PRINT #openfile%, "<META NAME=" + CHR$(34) + "GENERATOR" + CHR$(34) + " CONTENT=" + CHR$(34) + "Mozilla/3.01Gold (Win95; I) [Netscape]" + CHR$(34) + ">"
PRINT #openfile%, "<META NAME=" + CHR$(34) + "Description" + CHR$(34) + "CONTENT =" + CHR$(34) + "Quake console statistics. The generator of this HTML is done by Richard Maxwell" + CHR$(34) + ">"
PRINT #openfile%, "</HEAD>"
PRINT #openfile%, "<BODY TEXT=#C0C0C0 BGCOLOR=#000000 LINK=#8080FF VLINK=#0000FF ALINK=#FF0000>"


PRINT #openfile%, "<CENTER><H1>Stats Sorted by "; text$; "</H1><HR WIDTH=100%><DT>";
IF (flags% AND 16) <> 0 THEN PRINT #openfile%, "I <A HREF=rank.htm>Rank</A> "
IF (flags% AND 4) <> 0 THEN PRINT #openfile%, "I <A HREF=skill.htm>Skill</A> "
IF (flags% AND 32) <> 0 THEN PRINT #openfile%, "I <A HREF=eff.htm>Efficiency</A> "
IF (flags% AND 8) <> 0 THEN PRINT #openfile%, "I <A HREF=kills.htm>Kills</A> "
IF (flags% AND 2) <> 0 THEN PRINT #openfile%, "I <A HREF=deaths.htm>Deaths</A>"
IF (flags% AND 64) <> 0 THEN PRINT #openfile%, "I <A HREF=rankage.htm>Rank Age</A>"
IF (flags% AND 1) <> 0 THEN PRINT #openfile%, "I <A HREF=players.htm>Players</A>"
PRINT #openfile%, " I<HR WIDTH=100%></DT>"




PRINT #openfile%, "<FONT SIZE=-1>"



END SUB

FUNCTION htmlString$ (name$)

outstring$ = ""
dotstring$ = CHR$(133) + CHR$(143) + CHR$(142) + CHR$(156)
hashstring$ = CHR$(131) + CHR$(132) + CHR$(134) + CHR$(135) + CHR$(136) + CHR$(137)
numstring$ = "0123456789"
spaces$ = CHR$(138) + CHR$(140) + CHR$(160)

charcount% = FALSE

FOR I = 1 TO LEN(name$)

DO WHILE I > 28 AND charcount% = FALSE
char$ = MID$(name$, I, 1)
char2$ = MID$(name$, I + 1, 1)
IF INSTR(numstring$, char2$) > 0 OR char$ = "-" THEN
charcount% = TRUE
ELSE
I = I + 1
END IF
LOOP

IF I > 28 THEN
outstring$ = outstring$ + MID$(name$, I)
EXIT FOR

ELSE
sorted = FALSE
char$ = MID$(name$, I, 1)
achar = ASC(char$)
IF achar > 31 THEN
IF achar < 128 THEN outstring$ = outstring$ + char$: sorted = TRUE
IF sorted = FALSE AND INSTR(hashstring$, char$) > 0 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND INSTR(dotstring$, char$) > 0 THEN outstring$ = outstring$ + "<FONT COLOR=#FFFF00>.</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 145 AND achar < 156 THEN outstring$ = outstring$ + "<FONT COLOR=#804000>" + CHR$(ASC(char$) - 98) + "</FONT>": sorted = TRUE


IF sorted = FALSE AND (achar = 157 OR achar = 159) THEN outstring$ = outstring$ + "<FONT COLOR=#800000>-</FONT>": sorted = TRUE

IF sorted = FALSE AND achar = 128 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>(</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 129 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>=</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 130 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>)</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 139 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 158 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>=</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 141 THEN outstring$ = outstring$ + "<FONT COLOR=#FF0000>></FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 144 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>[</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 145 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>]</FONT>": sorted = TRUE
IF sorted = FALSE AND INSTR(spaces$, char$) > 0 THEN outstring$ = outstring$ + " ": sorted = TRUE

IF sorted = FALSE THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>" + CHR$(ASC(char$) - 128) + "</FONT>": sorted = TRUE
ELSE
IF achar > 17 AND achar < 27 THEN outstring$ = outstring$ + "<FONT COLOR=#804000>" + CHR$(ASC(char$) + 40) + "</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 1 AND achar < 5 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 5 AND achar < 10 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE


IF sorted = FALSE AND achar = 11 THEN outstring$ = outstring$ + "<FONT COLOR=#FFFFFF>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 16 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>[</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 17 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>]</FONT>": sorted = TRUE
IF sorted = FALSE AND (achar = 29 OR achar = 31) THEN outstring$ = outstring$ + "<FONT COLOR=#800000>-</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 30 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>=</FONT>": sorted = TRUE

END IF
IF sorted = FALSE THEN outstring$ = outstring$ + " "
END IF

NEXT

htmlString = outstring$
END FUNCTION

SUB showplayerdata

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%

count! = 1

GET #playerdata%, count!, tempplayer

DO WHILE NOT EOF(playerdata%)

GET #playerdata%, count!, tempplayer

IF tempplayer.skill > 999 THEN

PRINT #tempdata%, tempplayer.handle,
PRINT #tempdata%, (tempplayer.kills - tempplayer.deaths),
PRINT #tempdata%, tempplayer.skill,

LOCATE sline%, 1
PRINT "Players sorted by player number :"; count!;

IF (tempplayer.kills + tempplayer.deaths) = 0 THEN
PRINT #tempdata%, "0 %",
ELSE
PRINT #tempdata%, CINT(100 * tempplayer.kills / (tempplayer.kills + tempplayer.deaths)); "%",
END IF

PRINT #tempdata%, tempplayer.kills,
PRINT #tempdata%, tempplayer.deaths,
PRINT #tempdata%, (days! - tempplayer.lastseen)


END IF

count! = count! + 1

LOOP

CLOSE #tempdata%

LOCATE sline%, 1
PRINT "Players sorted by player number :"; count! - 2;


PRINT " . . . Writing HTML"

CALL dumptable(playerfile%)

REM --------old shit-----------

IF 0 = 2 THEN
PRINT #outfile%, "<TABLE BORDER=0 WIDTH=100%>"
PRINT #outfile%, "<TR>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Player</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Name</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Rank</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Skill</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Efficency</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Kills</TH>"
PRINT #outfile%, "<TH><FONT COLOR=#8080FF>Deaths</TH></FONT></TR>"


GET #playerdata%, 1, FileBuffer
temp2% = 1
DO WHILE (NOT EOF(playerdata%))

PRINT #outfile%, "<TR><TD>"; temp2%; "</TD>"
PRINT #outfile%, "<TD>"; htmlString(FileBuffer.handle); "</TD>"

PRINT #outfile%, "<TD>"; FileBuffer.kills - FileBuffer.deaths; "</TD>"

PRINT #outfile%, "<TD>"; FileBuffer.skill; "</TD>"

IF (FileBuffer.kills + FileBuffer.deaths) = 0 THEN
PRINT #outfile%, "<TD>0%</TD>"
ELSE
PRINT #outfile%, "<TD>"; CINT(100 * FileBuffer.kills / (FileBuffer.kills + FileBuffer.deaths)); "%</TD>"
END IF
PRINT #outfile%, "<TD>"; FileBuffer.kills; "</TD>"
PRINT #outfile%, "<TD>"; FileBuffer.deaths; "</TD></TR>"
temp2% = temp2% + 1
GET #playerdata%, temp2%, FileBuffer

LOOP

PRINT #outfile%, "</TABLE></FONT></CENTER></BODY></HTML>"

CLOSE #outfile%

END IF

REM ------------end of old shit------------


END SUB

